## slowmovideo 0.5+git20190116

=== CMakeLists.txt ===
message("==========================================================")
message("This CMake file is only here to give you this information:")
message("* To build slowmoVideo use the CMakeLists.txt file in the slowmoVideo subdirectory (inside the main directory).")
message("* To build flowBuilder (runs on nVidia GPUs) run cmake in the V3D subdirectory. (A CPU version is included in slowmoVideo and flowBuilder is not necessary anymore.)")
message("==========================================================")
message(FATAL_ERROR "Aborting therefore.")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(slowmoVideo)
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not allowed.")
endif()

set (CMAKE_BUILD_TYPE Release)
#set(CMAKE_BUILD_TYPE Debug)

#
set(CMAKE_MODULE_PATH
  ${slowmoVideo_SOURCE_DIR}/cmake
)

# Make a version file containing the current version from git.
#
include(GetGitRevisionDescription)
git_describe(VERSION --dirty=-dev)
if (VERSION)
				#parse the version information into pieces.
			  # v0.4.0-123-gdddf621
				string(REGEX REPLACE "^v([0-9]+)\\..*" "\\1" PROJECT_VERSION_MAJOR "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.([0-9]+).*" "\\1" PROJECT_VERSION_MINOR "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+-([0-9]+)-.*" "\\1" PROJECT_VERSION_PATCH "${VERSION}")
				string(REGEX REPLACE "^v[0-9]+\\.[0-9]+\\.[0-9]+-(.*)" "\\1" PROJECT_VERSION_SHA1 "${VERSION}")
else()
				set(PROJECT_VERSION_MAJOR "0")
				set(PROJECT_VERSION_MINOR "5")
				set(PROJECT_VERSION_PATCH "0")
endif()

if(NOT PROJECT_VERSION_PATCH)
				# git describe bug ?
				set(PROJECT_VERSION_PATCH "0")
endif()

set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
configure_file(version.h.in version.h)

### Compiler options ###

if (APPLE)
# To compile with clang:
#set(CMAKE_CXX_COMPILER "clang++")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall --verbose")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -mtune=corei7")

# Set additional project information
set(COMPANY "granjow")
set(COPYRIGHT "Copyright (c) 2011 Simon A. Eugster (Granjow). All rights reserved.")
set(IDENTIFIER "net.granjow.slomoui")

else()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -g")
endif()

if(CMAKE_TOOLCHAIN_FILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
  set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -DMXE")
endif(CMAKE_TOOLCHAIN_FILE)


### CMake Configuration ###
option (ENABLE_TESTS "Build the unit tests" FALSE)
set(ADDITIONAL_LIBS "")
if(MSYS)
  message(STATUS "MSYS system detected.")
  include("${PROJECT_SOURCE_DIR}/cmake/MingwCrossEnv.cmake")
endif(MSYS)


### Find packages ###


# Check if environment variable QTDIR is set.
# needed for Qt5
# Extra security for windows environment as well.
if (DEFINED ENV{QTDIR})
    set(CMAKE_PREFIX_PATH $ENV{QTDIR} ${CMAKE_PREFIX_PATH})
endif ()

if (APPLE)
				set(DEST "slowmoUI.app/Contents/Tools/bin")
else()
				set(DEST "bin")
endif()

include(cmake/macros.cmake)

# search for Qt4
if (NOT FORCE_QT4)
         find_package(Qt5Core QUIET)
         if (Qt5Core_FOUND) 
                 message(STATUS "Using qt5")
		 set(USE_QT TRUE)
		 # go on with other packages
		 find_package(Qt5 COMPONENTS Core Widgets Gui Xml Script)
		if (Qt5_POSITION_INDEPENDENT_CODE)
			set(CMAKE_POSITION_INDEPENDENT_CODE ON)
		endif(Qt5_POSITION_INDEPENDENT_CODE)
#		 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}
#		    ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")

		 include_directories(${Qt5Core_INCLUDES}) 
		 include_directories(${Qt5Widgets_INCLUDES}) 
		 include_directories(${Qt5Gui_INCLUDES}) 
		 include_directories(${Qt5Xml_INCLUDES}) 
		 include_directories(${Qt5Script_INCLUDES}) 

		 macro(qt_use_modules)
		    qt5_use_modules(${ARGN})
		 endmacro()
 
		 macro(qt_wrap_ui)
		     qt5_wrap_ui(${ARGN})
		 endmacro()
 
		 macro(qt_wrap_cpp)
		     qt5_wrap_cpp(${ARGN})
		 endmacro()
 
		 macro(qt_add_resources)
		     qt5_add_resources(${ARGN})
		 endmacro()
 
		 #find_package(Qt5LinguistTools REQUIRED)
		 macro(qt_add_translation)
		     qt5_add_translation(${ARGN})
		 endmacro()

		 macro(install_qt_executable)
			install_qt5_executable(${ARGN})
		 endmacro()
	 endif(Qt5Core_FOUND)
endif(NOT FORCE_QT4)

#old qt4 ...
if(NOT Qt5Core_FOUND) 

# should replace :
#SET(QT_USE_QTXML TRUE)
#SET(QT_USE_QTSCRIPT TRUE)
#find_package(Qt4)
#include(${QT_USE_FILE})
#include_directories(${QT_INCLUDES})

     message(STATUS "Could not find Qt5, searching for Qt4 instead...")
 
     set(NEEDED_QT4_COMPONENTS "QtCore" "QtXml" "QtGui" "QtScript") 
 
     find_package(Qt4 REQUIRED COMPONENTS ${NEEDED_QT4_COMPONENTS})

     macro(qt_use_modules)
 
     endmacro()
 
     macro(qt_wrap_ui)
         qt4_wrap_ui(${ARGN})
     endmacro()
 
     macro(qt_wrap_cpp)
         qt4_wrap_cpp(${ARGN})
     endmacro()
 
     macro(qt_add_resources)
         qt4_add_resources(${ARGN})
     endmacro()
 
     macro(qt_add_translation)
         qt4_add_translation(${ARGN})
     endmacro()
 
     macro(install_qt_executable)
         install_qt4_executable(${ARGN})
     endmacro()

     include(${QT_USE_FILE})
     add_definitions(${QT_DEFINITIONS})
 
     set(USE_QT TRUE)
endif()

message("Qt libraries found at : ${Qt5Gui_LIBRARIES} /  ${QT_LIBRARIES}" )

set (USE_QTKIT OFF CACHE BOOL "Build with the QTKit encoder")
set (USE_FFMPEG ON CACHE BOOL "Build with the FFMPEG encoder")
set (USE_DBUS OFF CACHE BOOL "Build with the DBUS notification support")

if(NOT MSYS)
	find_package(FFMPEG)
else(NOT MSYS)
    # Handled by MingwCrossEnv.cmake to avoid errors like:
    # libavformat.a(avisynth.o):avisynth.c:(.text+0x6b): undefined reference to `AVIStreamRelease@4'
endif(NOT MSYS)
# not here anymore
#include_directories(${FFMPEG_INCLUDE_DIR})
#include_directories("/usr/include/ffmpeg/")
#link_directories(${FFMPEG_LIBRARY_DIR})

if (APPLE AND USE_QTKIT)
	find_package(QTKIT)
	message(STATUS "QTKIT find at ${QTKIT_LIBRARY} ")
	set(ADDITIONAL_LIBS "-framework Cocoa -framework QTKit -framework QuartzCore -framework AppKit -framework OpenCL")
endif()
	
# Find OpenCV, you may need to set OpenCV_DIR variable
# to the absolute path to the directory containing OpenCVConfig.cmake file
# via the command line or GUI
find_package(OpenCV REQUIRED)
# If the package has been found, several variables will
# be set, you can find the full list with descriptions
# in the OpenCVConfig.cmake file. 
# Print some message showing some of them
message(STATUS "OpenCV library status:")
message(STATUS " version: ${OpenCV_VERSION}")
message(STATUS " libraries: ${OpenCV_LIBS}")
message(STATUS " include path: ${OpenCV_INCLUDE_DIRS}")

if (${OpenCV_VERSION_MAJOR} EQUAL 3)
				set(HAS_OCV_VERSION_3 ON)
else()
				set(HAS_OCV_VERSION_3 OFF)
endif()

include_directories(${OPENCV_INCLUDE_DIRS})

# for config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})



### Set up libraries ###
if(MSYS)
    set(EXTERNAL_LIBS ${FFMPEG_LIBRARIES} ${QT_LIBRARIES} ${OpenCV_LIBS_OPT} ${OpenCV_EXTRA_LIBS_OPT} ${ADDITIONAL_LIBS})
else(MSYS)
    set(EXTERNAL_LIBS ${QT_LIBRARIES} ${OpenCV_LIBS} ${ADDITIONAL_LIBS} ${FFMPEG_LIBRARIES})
endif(MSYS)


### Information output
set(BUILD_SLOWMO "NO")
#if(QT_LIBRARIES AND FFMPEG_FOUND)
if(USE_QT AND FFMPEG_FOUND)
set(BUILD_SLOWMO "YES")
#endif(QT_LIBRARIES AND FFMPEG_FOUND)
endif()
if(NOT FFMPEG_SWSCALE_FOUND)
  if(CMAKE_TOOLCHAIN_FILE)

  else(CMAKE_TOOLCHAIN_FILE)
  set(BUILD_SLOWMO "NO")
  endif(CMAKE_TOOLCHAIN_FILE)
endif(NOT FFMPEG_SWSCALE_FOUND)





## Include projects to build ##

include_directories(slowmoVideo/tr)
add_subdirectory(slowmoVideo/lib)
add_subdirectory(slowmoVideo/libgui)
add_subdirectory(slowmoVideo/project)
add_subdirectory(slowmoVideo/slowmoCLI)
add_subdirectory(slowmoVideo/slowmoUI)
add_subdirectory(slowmoVideo/slowmoFlowEdit)
add_subdirectory(slowmoVideo/slowmoInfo)
add_subdirectory(slowmoVideo/slowmoRenderer)
add_subdirectory(slowmoVideo/visualizeFlow)
if(ENABLE_TESTS)
  SET(QT_USE_QTTEST TRUE)
  ## add_subdirectory(slowmoVideo/test)
  add_subdirectory(slowmoVideo/unittests)
endif(ENABLE_TESTS)

##### SV END #####





##### V3D START #####

if(WIN32)
set(GLUT_ROOT_PATH ${PROJECT_SOURCE_DIR}/libs/)
endif(WIN32)

find_package(OpenGL)
find_package(GLEW)
find_package(GLUT)
find_package(JPEG)
find_package(PNG)
find_package(ZLIB)
#find_package(X11)

# Windows: Try to find libraries that could not be found manually in the libs/ directory.
if(WIN32)
	if(NOT ZLIB_FOUND)
		FIND_PATH(ZLIB_INCLUDE_DIR zlib.h
			PATHS ${PROJECT_SOURCE_DIR}/libs/include
		)
		find_library(ZLIB_LIBRARY NAMES zlib PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(ZLIB_INCLUDE_DIR AND ZLIB_LIBRARY)
			set(ZLIB_FOUND TRUE)
		endif(ZLIB_INCLUDE_DIR AND ZLIB_LIBRARY)
		message(STATUS "Manual search for zlib: ${ZLIB_LIBRARY} in ${ZLIB_INCLUDE_DIR}")
	endif(NOT ZLIB_FOUND)
	
	if(NOT PNG_FOUND)
		find_path(PNG_INCLUDE_DIR png.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)
		find_library(PNG_LIBRARIES libpng PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(PNG_INCLUDE_DIR AND PNG_LIBRARIES)
			set(PNG_FOUND TRUE)
		endif(PNG_INCLUDE_DIR AND PNG_LIBRARIES)
		message(STATUS "Manual search for png: ${PNG_LIBRARIES} in ${PNG_INCLUDE_DIR}")
	endif(NOT PNG_FOUND)
	
	if(NOT GLUT_FOUND)
		find_path(GLUT_LIBRARY_DIR NAMES GL/glut.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)
		find_library(GLUT_LIBRARIES glut32 PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(GLUT_LIBRARY_DIR AND GLUT_LIBRARIES)
			set(GLUT_FOUND TRUE)
		endif(GLUT_LIBRARY_DIR AND GLUT_LIBRARIES)
		message(STATUS "Manual search for GLUT: ${GLUT_LIBRARIES} in ${GLUT_LIBRARY_DIR}")
	endif(NOT GLUT_FOUND)

	if(NOT JPEG_FOUND)
		FIND_PATH(JPEG_INCLUDE_DIR jpeglib.h PATHS ${PROJECT_SOURCE_DIR}/libs/include)

		SET(JPEG_NAMES ${JPEG_NAMES} jpeg)
		FIND_LIBRARY(JPEG_LIBRARY NAMES ${JPEG_NAMES} PATHS ${PROJECT_SOURCE_DIR}/libs/lib)
		if(JPEG_INCLUDE_DIR AND JPEG_LIBRARY)
			set(JPEG_FOUND TRUE)
		endif(JPEG_INCLUDE_DIR AND JPEG_LIBRARY)
		message(STATUS "Manual search for JPEG: ${JPEG_LIBRARY} in ${JPEG_INCLUDE_DIR}")
	endif(NOT JPEG_FOUND)
endif(WIN32)


set(BUILD_FLOW_BUILDER "NO")
if(OPENGL_FOUND AND GLUT_FOUND AND GLEW_FOUND AND JPEG_FOUND AND PNG_FOUND)
	set(BUILD_FLOW_BUILDER "YES")
endif(OPENGL_FOUND AND GLUT_FOUND AND GLEW_FOUND AND JPEG_FOUND AND PNG_FOUND)

set(INCLUDE_SOURCE "YES")
if(DISABLE_INCLUDE_SOURCE)
	set(INCLUDE_SOURCE "NO")
add_definitions(-DDISABLE_INCLUDE_SOURCE)
endif(DISABLE_INCLUDE_SOURCE)


if (BUILD_FLOW_BUILDER)
    include_directories(${OPENGL_INCLUDE_DIR})
    include_directories(${GLUT_INCLUDE_DIR})
    include_directories(${GLEW_INCLUDE_DIR})
    include_directories(${JPEG_INCLUDE_DIR})
    include_directories(${ZLIB_INCLUDE_DIR})
    include_directories(${PNG_INCLUDE_DIR})


    set (V3D_DIR ${CMAKE_CURRENT_SOURCE_DIR}/V3D)
    set (V3D_INCLUDE_DIRS ${V3D_DIR}/.)

    include (V3D/Config/v3d_macros.cmake)
    include_directories(${V3D_INCLUDE_DIRS} ${EXTRA_INC_DIRS})

    add_definitions(-DDISABLE_REDEFINITIONS)
    #--------------------------------------------------
    enable_feature (V3DLIB_ENABLE_LIBJPEG)
    enable_feature (V3DLIB_ENABLE_LIBPNG)
    enable_feature_libraries (V3DLIB_ENABLE_LIBJPEG ${JPEG_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_LIBPNG ${PNG_LIBRARIES})

    enable_feature (V3DLIB_ENABLE_GPGPU)
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${OPENGL_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${GLEW_LIBRARIES})
    enable_feature_libraries (V3DLIB_ENABLE_GPGPU ${GLUT_glut_LIBRARY})
    #--------------------------------------------------


    include_directories(V3D/Config)

    set (GL_SRC
        V3D/GL/glsl_shaders.cpp
        V3D/GL/v3d_gpubase.cpp
        V3D/GL/v3d_gpuflow.cpp
        V3D/GL/v3d_gpucolorflow.cpp
        V3D/GL/v3d_gpupyramid.cpp
    )

    set (ALL_SRC
        ${GL_SRC}
        V3D/Config/config.h
        
        V3D/Base/v3d_image.cpp
        V3D/Base/v3d_imageprocessing.h
        V3D/Base/v3d_exception.h
        V3D/Base/v3d_timer.h
        V3D/Base/v3d_serialization.h
        V3D/Base/v3d_utilities.h
        V3D/Math/v3d_linear.h
        V3D/Math/v3d_linearbase.h
    )

    add_library(V3D STATIC ${ALL_SRC})
    target_link_libraries(V3D ${GLEW_LIBRARIES} X11)
    #install(TARGETS V3D DESTINATION lib)
    add_subdirectory(V3D/Apps)
endif (BUILD_FLOW_BUILDER)

##### V3D END #####





message("")

=== src/slowmoVideo/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 2.8

# Default target executed when no arguments are given to make.
default_target: all
.PHONY : default_target

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:

# Remove some rules from gmake that .SUFFIXES does not remove.
SUFFIXES =

.SUFFIXES: .hpux_make_needs_suffix_list

# Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:
.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/bin/cmake

# The command to remove a file.
RM = /usr/bin/cmake -E remove -f

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /home/mso/src/slowmoVideo/slowmoVideo

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /home/mso/src/slowmoVideo/slowmoVideo

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running interactive CMake command-line interface..."
	/usr/bin/cmake -i .
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache
.PHONY : edit_cache/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: install/local
.PHONY : install/local/fast

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: install/strip
.PHONY : install/strip/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components
.PHONY : list_install_components/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/usr/bin/cmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache
.PHONY : rebuild_cache/fast

# The main all target
all: cmake_check_build_system
	$(CMAKE_COMMAND) -E cmake_progress_start /home/mso/src/slowmoVideo/slowmoVideo/CMakeFiles /home/mso/src/slowmoVideo/slowmoVideo/CMakeFiles/progress.marks
	$(MAKE) -f CMakeFiles/Makefile2 all
	$(CMAKE_COMMAND) -E cmake_progress_start /home/mso/src/slowmoVideo/slowmoVideo/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	$(MAKE) -f CMakeFiles/Makefile2 clean
.PHONY : clean

# The main clean target
clean/fast: clean
.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	$(MAKE) -f CMakeFiles/Makefile2 preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	$(MAKE) -f CMakeFiles/Makefile2 preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

#=============================================================================
# Target rules for targets named sV

# Build rule for target.
sV: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sV
.PHONY : sV

# fast build rule for target.
sV/fast:
	$(MAKE) -f lib/CMakeFiles/sV.dir/build.make lib/CMakeFiles/sV.dir/build
.PHONY : sV/fast

#=============================================================================
# Target rules for targets named sVencode

# Build rule for target.
sVencode: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVencode
.PHONY : sVencode

# fast build rule for target.
sVencode/fast:
	$(MAKE) -f lib/CMakeFiles/sVencode.dir/build.make lib/CMakeFiles/sVencode.dir/build
.PHONY : sVencode/fast

#=============================================================================
# Target rules for targets named sVflow

# Build rule for target.
sVflow: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVflow
.PHONY : sVflow

# fast build rule for target.
sVflow/fast:
	$(MAKE) -f lib/CMakeFiles/sVflow.dir/build.make lib/CMakeFiles/sVflow.dir/build
.PHONY : sVflow/fast

#=============================================================================
# Target rules for targets named sVinfo

# Build rule for target.
sVinfo: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVinfo
.PHONY : sVinfo

# fast build rule for target.
sVinfo/fast:
	$(MAKE) -f lib/CMakeFiles/sVinfo.dir/build.make lib/CMakeFiles/sVinfo.dir/build
.PHONY : sVinfo/fast

#=============================================================================
# Target rules for targets named sVvis

# Build rule for target.
sVvis: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVvis
.PHONY : sVvis

# fast build rule for target.
sVvis/fast:
	$(MAKE) -f lib/CMakeFiles/sVvis.dir/build.make lib/CMakeFiles/sVvis.dir/build
.PHONY : sVvis/fast

#=============================================================================
# Target rules for targets named sVgui

# Build rule for target.
sVgui: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVgui
.PHONY : sVgui

# fast build rule for target.
sVgui/fast:
	$(MAKE) -f libgui/CMakeFiles/sVgui.dir/build.make libgui/CMakeFiles/sVgui.dir/build
.PHONY : sVgui/fast

#=============================================================================
# Target rules for targets named sVproj

# Build rule for target.
sVproj: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 sVproj
.PHONY : sVproj

# fast build rule for target.
sVproj/fast:
	$(MAKE) -f project/CMakeFiles/sVproj.dir/build.make project/CMakeFiles/sVproj.dir/build
.PHONY : sVproj/fast

#=============================================================================
# Target rules for targets named slowmoInterpolate

# Build rule for target.
slowmoInterpolate: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 slowmoInterpolate
.PHONY : slowmoInterpolate

# fast build rule for target.
slowmoInterpolate/fast:
	$(MAKE) -f slowmoCLI/CMakeFiles/slowmoInterpolate.dir/build.make slowmoCLI/CMakeFiles/slowmoInterpolate.dir/build
.PHONY : slowmoInterpolate/fast

#=============================================================================
# Target rules for targets named videoInfo

# Build rule for target.
videoInfo: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 videoInfo
.PHONY : videoInfo

# fast build rule for target.
videoInfo/fast:
	$(MAKE) -f slowmoCLI/CMakeFiles/videoInfo.dir/build.make slowmoCLI/CMakeFiles/videoInfo.dir/build
.PHONY : videoInfo/fast

#=============================================================================
# Target rules for targets named slowmoUI

# Build rule for target.
slowmoUI: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 slowmoUI
.PHONY : slowmoUI

# fast build rule for target.
slowmoUI/fast:
	$(MAKE) -f slowmoUI/CMakeFiles/slowmoUI.dir/build.make slowmoUI/CMakeFiles/slowmoUI.dir/build
.PHONY : slowmoUI/fast

#=============================================================================
# Target rules for targets named slowmoFlowEdit

# Build rule for target.
slowmoFlowEdit: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 slowmoFlowEdit
.PHONY : slowmoFlowEdit

# fast build rule for target.
slowmoFlowEdit/fast:
	$(MAKE) -f slowmoFlowEdit/CMakeFiles/slowmoFlowEdit.dir/build.make slowmoFlowEdit/CMakeFiles/slowmoFlowEdit.dir/build
.PHONY : slowmoFlowEdit/fast

#=============================================================================
# Target rules for targets named slowmoInfo

# Build rule for target.
slowmoInfo: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 slowmoInfo
.PHONY : slowmoInfo

# fast build rule for target.
slowmoInfo/fast:
	$(MAKE) -f slowmoInfo/CMakeFiles/slowmoInfo.dir/build.make slowmoInfo/CMakeFiles/slowmoInfo.dir/build
.PHONY : slowmoInfo/fast

#=============================================================================
# Target rules for targets named slowmoRenderer

# Build rule for target.
slowmoRenderer: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 slowmoRenderer
.PHONY : slowmoRenderer

# fast build rule for target.
slowmoRenderer/fast:
	$(MAKE) -f slowmoRenderer/CMakeFiles/slowmoRenderer.dir/build.make slowmoRenderer/CMakeFiles/slowmoRenderer.dir/build
.PHONY : slowmoRenderer/fast

#=============================================================================
# Target rules for targets named visualizeFlow

# Build rule for target.
visualizeFlow: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 visualizeFlow
.PHONY : visualizeFlow

# fast build rule for target.
visualizeFlow/fast:
	$(MAKE) -f visualizeFlow/CMakeFiles/visualizeFlow.dir/build.make visualizeFlow/CMakeFiles/visualizeFlow.dir/build
.PHONY : visualizeFlow/fast

#=============================================================================
# Target rules for targets named Test

# Build rule for target.
Test: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 Test
.PHONY : Test

# fast build rule for target.
Test/fast:
	$(MAKE) -f test/CMakeFiles/Test.dir/build.make test/CMakeFiles/Test.dir/build
.PHONY : Test/fast

#=============================================================================
# Target rules for targets named encodeFramesTest

# Build rule for target.
encodeFramesTest: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 encodeFramesTest
.PHONY : encodeFramesTest

# fast build rule for target.
encodeFramesTest/fast:
	$(MAKE) -f test/CMakeFiles/encodeFramesTest.dir/build.make test/CMakeFiles/encodeFramesTest.dir/build
.PHONY : encodeFramesTest/fast

#=============================================================================
# Target rules for targets named encodeTest

# Build rule for target.
encodeTest: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 encodeTest
.PHONY : encodeTest

# fast build rule for target.
encodeTest/fast:
	$(MAKE) -f test/CMakeFiles/encodeTest.dir/build.make test/CMakeFiles/encodeTest.dir/build
.PHONY : encodeTest/fast

#=============================================================================
# Target rules for targets named UnitTests

# Build rule for target.
UnitTests: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 UnitTests
.PHONY : UnitTests

# fast build rule for target.
UnitTests/fast:
	$(MAKE) -f unittests/CMakeFiles/UnitTests.dir/build.make unittests/CMakeFiles/UnitTests.dir/build
.PHONY : UnitTests/fast

# Help Target
help:
	@echo "The following are some of the valid targets for this Makefile:"
	@echo "... all (the default if no target is provided)"
	@echo "... clean"

=== src/V3D/Apps/CMakeLists.txt ===
if (V3DLIB_ENABLE_GPGPU)
  add_subdirectory(GL)
endif (V3DLIB_ENABLE_GPGPU)

=== src/slowmoVideo/lib/CMakeLists.txt ===
# Static libraries
# http://www.itk.org/pipermail/insight-users/2007-November/024141.html
# http://www.linux-magazin.de/Heft-Abo/Ausgaben/2007/02/Mal-ausspannen

set(LIB_SRC_BASE
  defs_sV.cpp
  defs_sV.hpp
  vector_sV.cpp
  shutter_sV.cpp
  intMatrix_sV.cpp
  interpolate_sV.cpp
  bezierTools_sV.cpp
  sourceField_sV.cpp
)

set(LIB_SRC_VIDEO
  defs_sV.h
  videoInfo_sV.cpp
  avconvInfo_sV.cpp
)

set(LIB_SRC_ARGS
  trivialArgsReader_sV.cpp
)

set(LIB_SRC_FLOW
  flowRW_sV.cpp
  flowField_sV.cpp
  flowTools_sV.cpp
  kernel_sV.cpp
)

set(LIB_SRC_FLOWVIS
  flowVisualization_sV.cpp
)

set(HEADERS
  flowRW_sV.h
  flowField_sV.h
  flowTools_sV.h
)


set(LIB_SRC_ENCODE
  macros_sV.h
  video_enc.h
  ffmpeg_writer.h
  ffmpeg_writer.cpp
  video_enc.cpp
)

set(SRCS_MOC
  ffmpeg_writer.h
)

qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

if (OLD_FFMPEG)
set(LIB_SRC_ENCODE
	${LIB_SRC_ENCODE}
	  ffmpegEncode_sV.c
)
endif()

if (APPLE AND USE_QTKIT)
set(LIB_SRC_ENCODE
	${LIB_SRC_ENCODE}
	qtkit.h
	qtkit.mm
)
endif()

set(SRCS_MOC
	ffmpeg_writer.h	
)

qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

message(STATUS "FFMPEG libraries are at ${FFMPEG_LIBRARIES}")

include_directories(${FFMPEG_INCLUDE_PATHS})
add_library(sV  STATIC ${LIB_SRC_BASE})
target_link_libraries(sV  ${QT_LIBRARIES})
qt_use_modules(sV Core)
qt_use_modules(sV Gui)

add_library(sVinfo  STATIC ${LIB_SRC_VIDEO})
qt_use_modules(sVinfo Core)
qt_use_modules(sVinfo Gui)
target_link_libraries(sVinfo  ${FFMPEG_LIBRARIES})

add_library(sVencode  STATIC ${LIB_SRC_ENCODE} ${MOC_OUT})
target_link_libraries(sVencode  ${FFMPEG_LIBRARIES})
qt_use_modules(sVencode Core)
qt_use_modules(sVencode Gui)

add_library(sVflow  STATIC ${LIB_SRC_FLOW})

add_library(sVvis  STATIC ${LIB_SRC_FLOWVIS})
qt_use_modules(sVvis Core)
qt_use_modules(sVvis Gui)
target_link_libraries(sVvis  sVflow ${QT_LIBRARIES})

=== src/slowmoVideo/libgui/CMakeLists.txt ===
set(SRCS
    imageDisplay.cpp
    combinedShortcuts.cpp
)

set(SRCS_MOC
    imageDisplay.h
    combinedShortcuts.h
)


qt_wrap_cpp(MOC_OUT ${SRCS_MOC})


include_directories(${CMAKE_BINARY_DIR}/libgui)

add_library(sVgui STATIC ${SRCS} ${MOC_OUT})
qt_use_modules(sVgui Core)
qt_use_modules(sVgui Gui)
qt_use_modules(sVgui Widgets)
target_link_libraries(sVgui  ${EXTERNAL_LIBS})

# If the library is used in a different project, cmake requires:
#include_directories(${slowmoVideo_SOURCE_DIR}/libgui)

=== src/slowmoVideo/project/CMakeLists.txt ===
set(SRCS_PROJ
  project_sV.cpp
  projectPreferences_sV.cpp
  renderPreferences_sV.cpp
  tag_sV.cpp
  node_sV.cpp
  nodeList_sV.cpp
  segment_sV.cpp
  segmentList_sV.cpp
  nodeHandle_sV.cpp
  renderTask_sV.cpp
  xmlProjectRW_sV.cpp
  abstractFrameSource_sV.cpp
  imagesFrameSource_sV.cpp
  videoFrameSource_sV.cpp
  emptyFrameSource_sV.cpp
  abstractRenderTarget_sV.cpp
  imagesRenderTarget_sV.cpp
  videoRenderTarget_sV.cpp
  abstractFlowSource_sV.cpp
  flowSourceOpenCV_sV.cpp
  flowSourceV3D_sV.cpp
  interpolator_sV.cpp
  shutterFunction_sV.cpp
  shutterFunctionList_sV.cpp
  motionBlur_sV.cpp
  canvasObject_sV.h
  exportVideoRenderTarget.cpp
  work_flow.cpp
)

if (OLD_FFMPEG)
set(SRCS_PROJ
	${SRCS_PROJ}
  new_videoRenderTarget.cpp
)
endif()

set(SRCS_MOC
  project_sV.h
  renderTask_sV.h
  abstractFrameSource_sV.h
  imagesFrameSource_sV.h
  videoFrameSource_sV.h
  emptyFrameSource_sV.h
  work_flow.h
)

qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

include_directories(${FFMPEG_INCLUDE_PATHS})
add_library(sVproj STATIC ${SRCS_PROJ} ${MOC_OUT})
qt_use_modules(sVproj Core)
qt_use_modules(sVproj Gui)
qt_use_modules(sVproj Xml)
qt_use_modules(sVproj Script)
target_link_libraries(sVproj sV sVinfo sVflow sVencode ${EXTERNAL_LIBS})

=== src/slowmoVideo/slowmoCLI/CMakeLists.txt ===


set(SOURCES_MAIN
  main.cpp
)

#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

set(SOURCES_VINFO
  videoInfo.cpp
)

add_executable(slowmoInterpolate ${SOURCES_MAIN})
target_link_libraries(slowmoInterpolate sV sVflow )

add_executable(slowmoVideoInfo ${SOURCES_VINFO})
target_link_libraries(slowmoVideoInfo sVinfo sV )

install(TARGETS slowmoInterpolate DESTINATION ${DEST})
install(TARGETS slowmoVideoInfo DESTINATION ${DEST})

=== src/slowmoVideo/slowmoFlowEdit/CMakeLists.txt ===

include_directories(${slowmoVideo_SOURCE_DIR})

set(SRCS
    main.cpp
    mainwindow.cpp
    flowEditCanvas.cpp
    shortcutListDialog.cpp
)

set(SRCS_UI
    mainwindow.ui
    flowEditCanvas.ui
    shortcutListDialog.ui
)


set(SRCS_MOC
    mainwindow.h
    flowEditCanvas.h
    shortcutListDialog.h
)

qt_wrap_ui(UI_H_OUT ${SRCS_UI})
qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

if(APPLE)
        set(BUNDLE "slowmoFlowEdit")
        set(ICONS_DIR "${${PROJECT_NAME}_SOURCE_DIR}/slowmoVideo/slowmoUI/res")
        message( "OS X build" )
        set(MACOSX_BUNDLE_INFO_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_BUNDLE_VERSION "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_LONG_VERSION_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
        set(MACOSX_BUNDLE_ICON_FILE "slowmoUI.icns")
        set(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
        set(MACOSX_BUNDLE_BUNDLE_NAME "${BUNDLE}")

        set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${BUNDLE}.app/Contents/Resources")
        set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
        SET_SOURCE_FILES_PROPERTIES(
           ${MACOSX_BUNDLE_ICON}
            PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
        message(STATUS "Bundle will be : ${MACOSX_BUNDLE} =>  ${PROJECT_NAME} ")

        set( SRCS ${SRCS} ${MACOSX_BUNDLE_ICON} )

endif()

include_directories(..)
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/slowmoFlowEdit)
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/libgui)

add_executable(slowmoFlowEdit WIN32 MACOSX_BUNDLE ${SRCS} ${MOC_OUT} ${UI_H_OUT})
qt_use_modules(slowmoFlowEdit Widgets Gui  Core )
target_link_libraries(slowmoFlowEdit sVgui sVflow sVvis)

#install(TARGETS slowmoFlowEdit
#        BUNDLE DESTINATION . COMPONENT Runtime
#        RUNTIME DESTINATION ${DEST} COMPONENT Runtime)

        #install(TARGETS slowmoUI DESTINATION ".")
        #install(TARGETS slowmoFlowEdit DESTINATION ${DEST})

if (Qt5Core_FOUND)
        include(DeployQt5) # 2.8.7 or later
else()
        include(DeployQt4) # 2.8.7 or later
endif()

if (APPLE)
       install(TARGETS slowmoFlowEdit DESTINATION ".")
       install_qt_executable(slowmoFlowEdit.app "" ""  )
elseif(WIN32)
       install(TARGETS slowmoFlowEdit DESTINATION ".")
       install_qt_executable(slowmoFlowEdit.exe "" ""  )
else()
       install(TARGETS slowmoFlowEdit DESTINATION ${DEST})
#       install_qt_executable(slowmoFlowEdit "" ""  )
endif()

=== src/slowmoVideo/slowmoInfo/CMakeLists.txt ===

message(STATUS "slowmoInfo Bundle will be : ${MACOSX_BUNDLE} =>  ${PROJECT_NAME} ")

add_executable(slowmoInfo slowmoInfo.cpp)
target_link_libraries(slowmoInfo sV ${EXTERNAL_LIBS})

install(TARGETS ${slowmoUI}
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)
#install(TARGETS slowmoInfo DESTINATION ${DEST})

=== src/slowmoVideo/slowmoRenderer/CMakeLists.txt ===

include_directories(..)

set(SRCS
    rendererMain.cpp
    slowmoRenderer_sV.cpp
)
set(SRCS_MOC
    slowmoRenderer_sV.h
)
qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

add_executable(slowmoRenderer ${SRCS} ${MOC_OUT})
target_link_libraries(slowmoRenderer sVproj ${EXTERNAL_LIBS})
qt_use_modules(slowmoRenderer Script Widgets Concurrent Gui  Core )
install(TARGETS slowmoRenderer DESTINATION ${DEST})

=== src/slowmoVideo/slowmoUI/CMakeLists.txt ===

# Building Qt+UI apps:
# http://www.qtcentre.org/wiki/index.php?title=Compiling_Qt4_apps_with_CMake
# http://www.cmake.org/pipermail/cmake/2008-September/023908.html



include_directories(${slowmoVideo_SOURCE_DIR})

set(SRCS
  main.cpp
  mainwindow.cpp
  canvas.cpp
  canvasTools.cpp
  flowEditCanvas.cpp
  frameMonitor.cpp
  renderPreview.cpp
  dialogues/newProjectDialog.cpp
  dialogues/preferencesDialog.cpp
  dialogues/projectPreferencesDialog.cpp
  dialogues/progressDialog.cpp
  dialogues/renderingDialog.cpp
  dialogues/shutterFunctionDialog.cpp
  dialogues/shutterFunctionFrame.cpp
  dialogues/flowExaminer.cpp
  dialogues/tagAddDialog.cpp
  dialogues/aboutDialog.cpp
  notificator.cpp
	logbrowserdialog.cpp
)

# notification
if (APPLE)
find_library(CORE_FOUNDATION NAMES CoreFoundation)
find_library(FOUNDATION NAMES Foundation)
find_library(APPLICATION_SERVICES NAMES ApplicationServices)
find_library(CORE_SERVICES NAMES CoreServices)
find_library(COCOA NAMES Cocoa)

SET(OSX_EXTRA_LIBS ${FOUNDATION} ${CORE_FOUNDATION} ${APPLICATION_SERVICES})
message(STATUS "OSX Additional libraries: ${OSX_EXTRA_LIBS}")

set(SRCS
        ${SRCS}
        macnotificationhandler.mm
)
endif()

set(SRCS_UI
  mainwindow.ui
  canvas.ui
  frameMonitor.ui
  renderPreview.ui
  flowEditCanvas.ui
  dialogues/newProjectDialog.ui
  dialogues/preferencesDialog.ui
  dialogues/projectPreferencesDialog.ui
  dialogues/progressDialog.ui
  dialogues/renderingDialog.ui
  dialogues/shutterFunctionDialog.ui
  dialogues/flowExaminer.ui
  dialogues/tagAddDialog.ui
  dialogues/aboutDialog.ui
)

set(SRCS_MOC
  mainwindow.h
  canvas.h
  frameMonitor.h
  flowEditCanvas.h
  renderPreview.h
  dialogues/newProjectDialog.h
  dialogues/preferencesDialog.h
  dialogues/projectPreferencesDialog.h
  dialogues/progressDialog.h
  dialogues/renderingDialog.h
  dialogues/shutterFunctionDialog.h
  dialogues/shutterFunctionFrame.h
  dialogues/flowExaminer.h
  dialogues/tagAddDialog.h
  dialogues/aboutDialog.h
  notificator.h
	logbrowserdialog.h
)

# notification
if (APPLE)
set(SRCS_MOC
        ${SRCS_MOC}
        macnotificationhandler.h
)
endif()

if(APPLE)
	set(BUNDLE "slowmoUI")
	set(ICONS_DIR "${${PROJECT_NAME}_SOURCE_DIR}/slowmoVideo/slowmoUI/res")
        message( "OS X build" )
        set(MACOSX_BUNDLE_INFO_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_BUNDLE_VERSION "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_LONG_VERSION_STRING "${BUNDLE} ${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
        set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT} )
        set(MACOSX_BUNDLE_ICON_FILE "slowmoUI.icns")
        set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER} )
        set(MACOSX_BUNDLE_BUNDLE_NAME "${BUNDLE}")

        set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${BUNDLE}.app/Contents/Resources")
        set(MACOSX_BUNDLE_ICON "${ICONS_DIR}/${MACOSX_BUNDLE_ICON_FILE}")
	SET_SOURCE_FILES_PROPERTIES(
	   ${MACOSX_BUNDLE_ICON} 
	    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
        message(STATUS "slowmoUI Bundle will be : ${MACOSX_BUNDLE} ")

	set( SRCS ${SRCS} ${MACOSX_BUNDLE_ICON} )

  set(INFO_PLIST_FILENAME ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  configure_file(${CMAKE_SOURCE_DIR}/slowmoVideo/slowmoUI/res/Info.plist.in ${INFO_PLIST_FILENAME})
  set_target_properties(${PROGNAME} PROPERTIES
                        MACOSX_BUNDLE_INFO_PLIST ${INFO_PLIST_FILENAME} )
  #ADD_CUSTOM_COMMAND(TARGET slowmoUI
  #  POST_BUILD
  #  COMMAND cp Info.plist slowmoUI.app/Contents/Info.plist
  #  COMMENT "Updating Info.plist"
  #  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )

endif()

# Without these includes the promoted widgets fail to compile
# since the headers are not found. (For whatever reason.)
include_directories(dialogues)
include_directories(.)
include_directories(..)

# Embed images in the binary
set(SRC_RES resources.qrc)
qt_add_resources(RES_OUT ${SRC_RES})

# Generate header files from the .ui files
qt_wrap_ui(UI_H_OUT ${SRCS_UI})
qt_wrap_cpp(MOC_OUT ${SRCS_MOC})

# Include the generated header files
include_directories(${CMAKE_BINARY_DIR}/slowmoVideo/slowmoUI)


link_directories(${FFMPEG_LIBRARY_DIR})
add_executable(slowmoUI WIN32 MACOSX_BUNDLE ${SRCS} ${MOC_OUT} ${UI_H_OUT} ${RES_OUT})
qt_use_modules(slowmoUI Script Widgets Concurrent Gui  Core )
target_link_libraries(slowmoUI sVproj sVvis sVgui ${OSX_EXTRA_LIBS})

#install(TARGETS ${slowmoUI}
#        BUNDLE DESTINATION . COMPONENT Runtime
#        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)

if (UNIX AND NOT APPLE)
# create desktop file for KDE/Gnome
# desktop file section
	file( WRITE "${PROJECT_BINARY_DIR}/slowmoUI.desktop"
"#!/usr/bin/env xdg-open
[Desktop Entry]
Type=Application
Comment=Slow Motion Video
Exec=${CMAKE_INSTALL_PREFIX}/bin/slowmoUI
GenericName=slowmoVideo
Icon=${CMAKE_INSTALL_PREFIX}/share/icons/AppIcon.png
MimeType=
Name=slowmoUI
Terminal=false
Categories=Qt;AudioVideo;Video;\n")

	#install ( FILES icons/slowmoUI.png DESTINATION share/icons )
	install ( FILES res/AppIcon.png DESTINATION share/icons )
	install ( FILES ${PROJECT_BINARY_DIR}/slowmoUI.desktop DESTINATION share/applications
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)
endif()

if (Qt5Core_FOUND)
	include(DeployQt5) # 2.8.7 or later
else()
	include(DeployQt4) # 2.8.7 or later
endif()

#set( PLUGINS "qjpeg;qtiff" )
set( PLUGINS qjpeg )
if (APPLE)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt_executable(slowmoUI.app "${PLUGINS}"  )
elseif(WIN32)
       install(TARGETS slowmoUI DESTINATION ".")
       install_qt_executable(slowmoUI.exe "${PLUGINS}"  )
else()
       install(TARGETS slowmoUI DESTINATION ${DEST})
#       install_qt_executable(slowmoUI "${PLUGINS}"  )
endif()

=== debian/changelog ===
slowmovideo (0.5+git20190116-3build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:24:43 +0100

slowmovideo (0.5+git20190116-3build1) focal; urgency=medium

  * No-change upload for opencv soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2020 10:49:25 +0100

slowmovideo (0.5+git20190116-3) unstable; urgency=medium

  * Upload to unstable.
  * Bump standards version to 4.4.1.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 28 Oct 2019 14:02:42 +0100

slowmovideo (0.5+git20190116-2) experimental; urgency=medium

  * Apply patch for opencv4 to fix FTBFS. (Closes: #922598)
  * Bump standards version to 4.4.0.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 06 Sep 2019 11:08:02 +0200

slowmovideo (0.5+git20190116-1) unstable; urgency=medium

  * Initial release. (Closes: #717369)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 16 Jan 2019 09:02:04 +0100

=== debian/control ===
Source: slowmovideo
Section: video
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), cmake, qtbase5-dev, qtscript5-dev, libopencv-dev (>= 4)
Standards-Version: 4.4.1
Homepage: http://slowmovideo.granjow.net/

Package: slowmovideo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg
Description: create slow-motion videos from your footage
 This does not simply make your videos play at 0.01 x speed. You can
 smoothly slow down and speed up your footage, optionally with motion
 blur.
 .
 How does slow motion work? slowmoVideo tries to find out where pixels
 move in the video (this information is called Optical Flow), and then
 uses this information to calculate the additional frames.
 .
 Videos in any format supported by ffmpeg can be loaded. Image sequences
 can also be loaded, so, if you did a timelapse with too few frames,
 slowmoVideo may help as well.
 slowmoVideo does not work with a constant slowdown factor but with
 curves that allow arbitrary time accelereation/deceleration/reversal.
 Motion blur can be added, as much as you want.

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%" \
   https://github.com/slowmoVideo/slowmoVideo/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
